#!/usr/bin/python

import threading
import commands
import sys
import os

#limit=int(sys.argv[1])
ignore={}
result_list={}
ignore_file="/etc/zabbix/scripts/data/nf_ignore.txt"
r_list=commands.getoutput('ip netns list | grep qrouter').split()
threads=[]

# Ignore List Get
if os.path.isfile(ignore_file):
    f=open(ignore_file,"r")
    ig_list=f.readlines()

    for line in ig_list:
        text=line.strip()
        q=text.split()
        ignore[q[0]]=q[1]
    f.close()

# Thread function
class ExecThread(threading.Thread):
    global result_list
    def __init__(self, command):
        threading.Thread.__init__(self)
        self.command=command

    def run(self):
        run_cmd="ip netns exec %s cat /proc/sys/net/netfilter/nf_conntrack_count" %self.command
        result=commands.getoutput(run_cmd).strip()
        result_list[self.command]=result

# Command Excute
for i in r_list:
    t_job=ExecThread(i.strip())
    t_job.start()
    threads.append(t_job)

for th in threads:
    th.join()

# Error Check...
err=0
err_msg=""

for i in r_list:
    #
    limit=300000  ## nf_conntrack_limit
    #
    if ignore.get(i):
        limit=int(ignore.get(i))
    try:
        if int(result_list[i]) > limit:
            err=err+1
            err_msg=err_msg+" %s : %s," %(i, result_list[i])
    except ValueError:
        #check again existance
        router_exist_cmd="ip netns list | grep %s" %(i)
        status=commands.getstatusoutput(router_exist_cmd)
        if status[0] != 0: #ignore removed whie checking
            continue
        else:
            err=err+1
            err_msg=err_msg+" %s : %s %s," %(i, "[ValueError]", result_list[i])

if err != 0:
    err_msg="%d routers nf_conntrack_current is exceed =>" %err +err_msg.strip(',')
    print err_msg
else:
    print "nf_conntrack_OK"
